/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.fidufosyga.rules;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 *
 * @author Marinela.QuinteroT1
 */
public class NoCoincideExpresionRegularNov extends AbstractRule {

    private Pattern pattern;

    @Override
    public void setParams(Object[] params) {
        String patternStr = (String) params[2];
        patternStr = patternStr.replace("#", ","); // Reemplazo especial
        pattern = Pattern.compile(patternStr);
        super.setParams(params);
    }

    @Override
    public boolean performValidation(String field, String[] registro, String nombreArchivo) {
        int campoDepNovedad = Integer.parseInt((String) getParams()[0]);
        String novedadEsperada = (String) getParams()[1];

        if (campoDepNovedad >= registro.length) {
            return false; // índice fuera de rango
        }

        String tipoNovedad = registro[campoDepNovedad];

        // Solo validar si coincide el tipo de novedad
        if (tipoNovedad.equals(novedadEsperada)) {

            // Acepta el campo si está vacío
            if (field == null || field.trim().isEmpty()) {
                return false;
            }

            Matcher matcher = pattern.matcher(field);
            return !matcher.matches(); // Retorna true si NO cumple la expresión
        }

        return false; 
    }
}

